Index: issm/trunk/src/c/objects/Bamg/Metric.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/Metric.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Metric.cpp	(revision 3913)
@@ -0,0 +1,331 @@
+#include <cstdio>
+#include <string.h>
+#include <cmath>
+
+#include "Metric.h"
+#include "../../include/include.h"
+#include "../../shared/Exceptions/exceptions.h"
+
+using namespace std;
+
+namespace bamg {
+
+	SaveMetricInterpole  LastMetricInterpole;
+
+	/*Constructor/Destructor*/
+	/*FUNCTION Metric::Metric(const double  a[3],const  Metric m0, const  Metric m1,const  Metric  m2 ){{{1*/ 
+	Metric::Metric(const double  a[3],const  Metric m0, const  Metric m1,const  Metric m2 ){
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Metric.cpp/Metric)*/
+
+		Metric mab(a[0]*m0.a11 + a[1]*m1.a11 + a[2]*m2.a11,
+					a[0]*m0.a21 + a[1]*m1.a21 + a[2]*m2.a21,
+					a[0]*m0.a22 + a[1]*m1.a22 + a[2]*m2.a22);
+
+		MatVVP2x2 vab(mab);
+
+		R2 v1(vab.v.x,vab.v.y);
+		R2 v2(-v1.y,v1.x);
+
+		double h1 = a[0] / m0(v1) + a[1] / m1(v1) + a[2] / m2(v1);
+		double h2 = a[0] / m0(v2) + a[1] / m1(v2) + a[2] / m2(v2);
+
+		vab.lambda1 =  1 / (h1*h1);
+		vab.lambda2 =  1 / (h2*h2);
+		*this = vab;
+	}
+	/*}}}1*/
+	/*FUNCTION Metric::Metric( double  a,const  Metric ma, double  b,const  Metric mb){{{1*/
+	Metric::Metric( double  a,const  Metric ma, double  b,const  Metric mb) { 
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Metric.cpp/MatVVP2x2)*/
+
+		Metric mab(a*ma.a11+b*mb.a11,a*ma.a21+b*mb.a21,a*ma.a22+b*mb.a22);
+		MatVVP2x2 vab(mab);
+
+		R2 v1(vab.v.x,vab.v.y);
+		R2 v2(-v1.y,v1.x);
+
+
+		double h1 = a / ma(v1) + b / mb(v1);
+		double h2 = a / ma(v2) + b / mb(v2);
+		vab.lambda1 =  1 / (h1*h1);
+		vab.lambda2 =  1 / (h2*h2);
+		*this = vab;
+	}
+	/*}}}1*/
+
+	/*Methods*/
+	/*FUNCTION Metric::Echo {{{1*/
+	void Metric::Echo(void){
+
+		printf("Metric:\n");
+		printf("   [a11 a21 a22]: [%g %g %g]\n",a11,a21,a22);
+
+		return;
+	}
+	/*}}}*/
+	/*FUNCTION Metric::IntersectWith{{{1*/
+	int Metric::IntersectWith(const Metric M2) {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Metric.cpp/IntersectWith)*/
+
+		/*Get a new metric from an existing metric (M1=this)
+		 * and a new metric given in input M2 using a 
+		 * Simultaneous Matrix Reduction:
+		 * If M1 and M2 are 2 metrics, we must build N=M1^-1 M2 (Alauzet2003 p16) 
+		 * the eigen vectors of N form a matrix P
+		 * The new metric M = M1 inter M2 is then given by:
+		 *
+		 *      -T [ max(lambda1, mu1)          0         ]  -1				 
+		 * M = P   [                                      ] P		 
+		 *         [        0            max(lambda2, mu2)] 
+		 *
+		 * where lambdai and mui can be computed using Rayleigh formula: 
+		 *    lambdai = vi' M1 vi
+		 * with vi eigen vectors of N (columns of P)
+		 */
+
+		int         change=0;
+		Metric &M1=*this;
+		D2xD2       P;
+
+		//Get P, eigen vectors of N=inv(M1) M2
+		SimultaneousMatrixReduction(*this,M2,P);
+
+		//extract the eigen vectors of P (columns)
+		R2 v1(P.x.x,P.y.x);
+		R2 v2(P.x.y,P.y.y);
+
+		//compute lambdai mui
+		double lambda1=M1(v1,v1);
+		double lambda2=M1(v2,v2);
+		double mu1=M2(v1,v1);
+		double mu2=M2(v2,v2);
+
+		//check where any change needs to be done on M1
+		if ( lambda1 < mu1 )  change=1,lambda1=mu1;
+		if ( lambda2 < mu2 )  change=1,lambda2=mu2; 
+
+		//update M1 if necessary
+		if (change) {
+			D2xD2 invP(P.inv());
+			D2xD2 D(lambda1,0,0,lambda2); 
+			D2xD2 M(invP.t()*D*invP);
+			a11=M.x.x;
+			a21=0.5*(M.x.y+M.y.x);
+			a22=M.y.y;
+		}
+		return change;
+	}
+	/*}}}1*/
+
+	/*Intermediary*/
+	/*FUNCTION LengthInterpole{{{1*/
+	double LengthInterpole(const Metric Ma,const  Metric Mb, R2 AB) {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Metric.cpp/LengthInterpole)*/
+
+		double k=1./2.;
+		int level=0;
+		static int kkk=0;
+		static  Metric Ms1[32],Ms2[32];
+		static double lMs1[32],lMs2[32];
+		static double K[32];
+		double l=0,sss=0;
+		Ms1[level]=Ma;
+		Ms2[level]=Mb;
+		double sa =  Ma(AB);
+		double sb =  Mb(AB);
+		lMs1[level]=sa;
+		lMs2[level]=sb;
+		K[level]=k;
+		level++;
+		int i=0;
+		double * L= LastMetricInterpole.L, *S = LastMetricInterpole.S;
+		double  sstop = 0.1; // Max(0.6,(sa+sb)/5000);
+		while (level) {
+			level--;
+			Metric M1=Ms1[level];
+			Metric M2=Ms2[level];
+			k=K[level];
+			double s1=  lMs1[level];
+			double s2=  lMs2[level];
+
+			double s= (s1+s2)*k;
+			if( s > sstop   && level < 30 && i < 500-level ) {
+				Metric Mi(0.5,M1,0.5,M2);
+				double si = Mi(AB);
+				if( Abs((s1+s2)-(si+si)) > s1*0.001) 
+				  {
+					k=k/2;
+					// we begin by the end to walk in the correct sens from a to b
+					// due to the stack 
+					Ms1[level]=Mi;
+					Ms2[level]=M2;
+					lMs1[level]=si;
+					lMs2[level]=s2;
+					K[level]=k;
+					level++;
+					Ms1[level]=M1;
+					Ms2[level]=Mi;
+					lMs1[level]=s1;
+					lMs2[level]=si;
+					K[level]=k;
+					level++;
+				  }
+				else
+				 L[i]= l += s,S[i]=sss+=k,i++;
+			}
+			else 
+			 L[i]= l += s,S[i]=sss+=k,i++;
+		}
+		// warning for optimisation S is in [0:0.5] not in [0:1]
+		if (i>=512){
+			ISSMERROR("i>=512");
+		}
+		LastMetricInterpole.lab=l;
+		LastMetricInterpole.opt=i;
+		if (i>200 && kkk++<10) printf("WARNING: LengthInterpole: ( i=%i l=%i sss=%i ) %g\n",i,l,sss,sstop); 
+		return l;
+	}
+	/*}}}1*/
+	/*FUNCTION SimultaneousMatrixReduction{{{1*/
+	void SimultaneousMatrixReduction( Metric M1,  Metric M2, D2xD2 &V) {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Metric.cpp/ReductionSimultanee)*/
+
+		/*In this routine we must return a matrix V that is composed of the 
+		 * eigen vectors of N=inv(M1) M2.
+		 * Instead of looking at N directly, we are going to use the fact that
+		 * M1 and M2 are symmetrical, positive definite. 
+		 * The eigen values of N are given by solving
+		 *    inv(M1) M2 V = lambda V
+		 * which is equivalent to
+		 *    M2 V = lambda M1 V
+		 * and we will hence solve
+		 *    (M2 - lambda M1) V = 0
+		 */
+
+		int i;
+
+		//M1 and M2 components
+		double a11=M1.a11,a21=M1.a21,a22=M1.a22;
+		double b11=M2.a11,b21=M2.a21,b22=M2.a22;
+
+		/*To get the eigen values, we solve the following problem:
+		 *    det(M2-lambda M1) = 0
+		 *    (b11 - lambda a11)(b22-lambda a22) - (b21-lambda a21)^2
+		 * and we have the following trinome:
+		 *    a lambda^2 + b lambda + c =0
+		 * with:
+		 *    a = a11 a22 - a21 a21 (=det(M1))
+		 *    b = -a11 b22 -b11 a22 + 2 b21 a21
+		 *    c = b11 b22 - b21 b21 (=det(M2))
+		 *    */
+		const double a= a11*a22  - a21*a21;
+		const double b=-a11*b22 - b11*a22+2*b21*a21;
+		const double c=-b21*b21 + b11*b22;
+		const double bb=b*b,ac=a*c;
+		const double delta= bb-4*ac;
+
+		// first, case of a double root if:
+		//  - all the terms are very small (a??)
+		//  - or : delta is very small
+		if ( (bb + Abs(ac) < 1.0e-34 ) ||  (delta < 1.0e-6*bb) ){
+			//all vectors are eigen vectors -> choose 1,0 and 0,1
+			V= D2xD2(1,0,0,1);
+		}
+
+		//general case: two distinct roots: lambda1 and lambda2
+		else {
+
+			/*Compute eigen values*/
+			const double delta2 = sqrt(delta);
+			double lambda[2];
+			lambda[0]= (-b - delta2)/(2*a);
+			lambda[1]= (-b + delta2)/(2*a);
+
+			/*compute eigen vectors*/
+			double vp[2][2];
+			double v0,v1,v2;
+			double s0,s1;
+
+			for(i=0;i<2;i++){
+				/*Now, one must find the eigen vectors. For that we use the 
+				 * following property of the scalare product
+				 *    (Ax,b) = transp(b) Ax = transp(x) transp(A) b
+				 *           = (transp(A) b ,x)
+				 * Here we are dealing with A= M2 - lambda M1 which is symmetrical:
+				 *    for all (x,y) in R2 
+				 *       ((M2 - lambda M1)x,y)=((M2 - lambda M1)y,x)
+				 * If y is in Ker(M2 - lambda M1):
+				 *    for all x in R2
+				 *       ((M2 - lambda M1)y,x)=0
+				 * This shows that:
+				 *    Ker(M2 - lambda M1) is orthogonal to Im(M2 - lambda M1)
+				 * To find the eigen vectors, we only have to find two vectors
+				 * of the image and take their perpendicular as long as they are
+				 * not 0.
+				 * To do that, we take (1,0) and (0,1) and take the larger norm*/
+
+				//compute V = M2 - lambdai M1
+				v0 = b11 - lambda[i]*a11;
+				v1 = b21 - lambda[i]*a21;
+				v2 = b22 - lambda[i]*a22;
+
+				// compute s1=norm(V(1,0)) and s0=norm(V(0,1))
+				s0 = v0*v0 + v1*v1;
+				s1 = v1*v1 + v2*v2;
+
+				//compute vp1 = (vp1x,vp1y)
+				if(s1 < s0){
+					s0=sqrt(s0);
+					vp[0][i]=   v1/s0;
+					vp[1][i]= - v0/s0;
+				}
+				else{
+					s1=sqrt(s1);
+					vp[0][i]=   v2/s1;
+					vp[1][i]= - v1/s1;
+				}
+			}
+
+			//compute V from vp
+			V=D2xD2(vp[0][0],vp[0][1],vp[1][0],vp[1][1]);
+		}
+	}
+	/*}}}1*/
+	/*FUNCTION abscisseInterpole{{{1*/
+	double abscisseInterpole(const Metric Ma,const  Metric Mb, R2 AB,double s,int optim) { 
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Metric.cpp/abscisseInterpole)*/
+
+		if(!optim)  LengthInterpole(Ma,Mb,AB);
+		double l  = s* LastMetricInterpole.lab,r;
+		int j=LastMetricInterpole.opt-1,i=0,k;
+
+		double * L= LastMetricInterpole.L, *S = LastMetricInterpole.S;
+		// warning for optimisation S is the abcisse in [0:0.5]
+		// and L is le lenght 
+		if(l<=L[0])
+		 r=2*S[0]*l/L[0];
+		else if (l>=L[j])
+		 r=1;
+		else 
+		  {
+			while (j-i>1)
+			  {
+				k= (i+j)/2;
+				if(l<=L[k])
+				 j=k;// l<=L[j] 
+				else
+				 i=k; //  L[i]<l
+			  };
+			if (i==j)
+			 r = 2*S[i];
+			else
+			 r =  2*(S[i]*(L[j]-l)+ S[j]*(l-L[i]))/(L[j]-L[i]);
+		  }
+		if (r>1 || r<0){
+			ISSMERROR("r>1 || r<0");
+		}
+		return r ;
+	}
+	/*}}}1*/
+
+}
Index: issm/trunk/src/c/objects/Bamg/Metric.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/Metric.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Metric.h	(revision 3913)
@@ -0,0 +1,126 @@
+#ifndef _METRIC_H
+#define _METRIC_H
+
+#include "./include.h"
+#include "../../shared/Bamg/shared.h"
+#include "R2.h"
+
+namespace bamg {
+
+	typedef P2<double,double>    D2;
+	typedef P2xP2<double,double> D2xD2;
+
+	class Metric;
+	class MatVVP2x2;
+
+
+	class Metric{
+
+		public:
+			//fields
+			double a11,a21,a22;
+			//friends
+			friend class MatVVP2x2;
+			//functions
+			Metric(){};
+			Metric(const MatVVP2x2);
+			Metric(double a): a11(1/(a*a)),a21(0),a22(1/(a*a)){}
+			Metric(double a,double b,double c) :a11(a),a21(b),a22(c){}
+			Metric( double  a,const  Metric ma, double  b,const  Metric mb);
+			Metric(const double  a[3],const  Metric m0,const  Metric m1,const  Metric m2 );
+			void  Echo();
+			R2    mul(const R2 x)const {return R2(a11*x.x+a21*x.y,a21*x.x+a22*x.y);}
+			double det() const {return a11*a22-a21*a21;}  
+			R2    Orthogonal(const R2 x){return R2(-(a21*x.x+a22*x.y),a11*x.x+a21*x.y);}
+			R2    Orthogonal(const I2 x){return R2(-(a21*x.x+a22*x.y),a11*x.x+a21*x.y);}
+			int   IntersectWith(const Metric M2);
+			inline void Box(double &hx,double &hy) const ;  
+			//operators
+			Metric operator*(double c) const {double c2=c*c;return  Metric(a11*c2,a21*c2,a22*c2);} 
+			Metric operator/(double c) const {double c2=1/(c*c);return  Metric(a11*c2,a21*c2,a22*c2);} 
+			operator D2xD2(){ return D2xD2(a11,a21,a21,a22);}
+			double  operator()(R2 x) const { return sqrt(x.x*x.x*a11+2*x.x*x.y*a21+x.y*x.y*a22);};
+			double  operator()(R2 x,R2 y) const { return x.x*y.x*a11+(x.x*x.y+x.y*y.x)*a21+x.y*y.y*a22;};
+
+	};
+
+	class MatVVP2x2{
+		public:
+			//fields
+			double lambda1,lambda2;
+			D2     v;
+			//friends
+			friend  class Metric;
+			//functions
+			MatVVP2x2(const Metric );
+			MatVVP2x2(double r1,double r2,const D2 vp1): lambda1(r1),lambda2(r2),v(vp1){}
+			void  Echo();
+			void  Abs(){lambda1=bamg::Abs(lambda1),lambda2=bamg::Abs(lambda2);}
+			void  pow(double p){lambda1=::pow(lambda1,p);lambda2=::pow(lambda2,p);}
+			void  Min(double a) { lambda1=bamg::Min(a,lambda1); lambda2=bamg::Min(a,lambda2) ;}
+			void  Max(double a) { lambda1=bamg::Max(a,lambda1); lambda2=bamg::Max(a,lambda2) ;}
+			void Minh(double h) {Min(1.0/(h*h));}
+			void Maxh(double h) {Max(1.0/(h*h));}
+			void Isotrope() {lambda1=lambda2=bamg::Max(lambda1,lambda2);}
+			double hmin() const {return sqrt(1/bamg::Max3(lambda1,lambda2,1e-30));}
+			double hmax() const {return sqrt(1/bamg::Max(bamg::Min(lambda1,lambda2),1e-30));}
+			double lmax() const {return bamg::Max3(lambda1,lambda2,1e-30);}
+			double lmin() const {return bamg::Max(bamg::Min(lambda1,lambda2),1e-30);}
+			double Aniso2() const  { return lmax()/lmin();}
+			double Aniso() const  { return sqrt( Aniso2());}
+			void BoundAniso(const double c){ BoundAniso2(1/(c*c));}
+			inline void BoundAniso2(const double coef);
+			//operators
+			void operator *=(double coef){ lambda1*=coef;lambda2*=coef;}
+	};
+
+	class SaveMetricInterpole {
+		friend double LengthInterpole(const Metric ,const  Metric , R2 );
+		friend double abscisseInterpole(const Metric ,const  Metric , R2 ,double ,int );
+		int opt;
+		double lab;
+		double L[1024],S[1024];
+	};
+
+	extern SaveMetricInterpole  LastMetricInterpole; // for optimization 
+	//Functions
+	void  SimultaneousMatrixReduction( Metric M1,  Metric M2,D2xD2 &V);
+	double LengthInterpole(const Metric Ma,const  Metric Mb, R2 AB);
+	double abscisseInterpole(const Metric Ma,const  Metric Mb, R2 AB,double s,int optim=0);
+
+	//inlines
+	inline void  MatVVP2x2::BoundAniso2(const double coef){
+		if (coef<=1.00000000001){
+			if (lambda1 < lambda2)
+			 lambda1 = bamg::Max(lambda1,lambda2*coef);
+			else
+			 lambda2 = bamg::Max(lambda2,lambda1*coef);
+		}
+		else{  //TO BE CHECKED
+			if (lambda1 > lambda2)
+			 lambda1 = bamg::Min(lambda1,lambda2*coef);
+			else
+			 lambda2 = bamg::Min(lambda2,lambda1*coef);
+		}
+	}
+	inline Metric::Metric(const MatVVP2x2 M) {
+		double v00=M.v.x*M.v.x;
+		double v11=M.v.y*M.v.y;
+		double v01=M.v.x*M.v.y;
+		a11=v00*M.lambda1+v11*M.lambda2;
+		a21=v01*(M.lambda1-M.lambda2);
+		a22=v00*M.lambda2+v11*M.lambda1;
+	}
+	inline   void  Metric::Box(double &hx,double &hy) const {
+		double d=  a11*a22-a21*a21;
+		hx = sqrt(a22/d);
+		hy = sqrt(a11/d);
+	}
+	inline double LengthInterpole(double la,double lb) {
+		return ( Abs(la - lb) < 1.0e-6*Max3(la,lb,1.0e-20) ) ?  (la+lb)/2  : la*lb*log(la/lb)/(la-lb);
+	}
+	inline double abscisseInterpole(double la,double lb,double lab,double s){
+		return ( Abs(la - lb) <1.0e-6*Max3(la,lb,1.0e-20))  ? s : (exp(s*lab*(la-lb)/(la*lb))-1)*lb/(la-lb);
+	}
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/QuadTree.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/QuadTree.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/QuadTree.cpp	(revision 3913)
@@ -0,0 +1,553 @@
+#include <limits.h>
+#include <string.h>
+#include <stdlib.h>
+
+#include "../objects.h"
+
+namespace bamg {
+
+	/*MACROS {{{1*/
+#define INTER_SEG(a,b,x,y) (((y) > (a)) && ((x) <(b)))
+#define ABS(i) ((i)<0 ?-(i) :(i))
+#define MAX1(i,j) ((i)>(j) ?(i) :(j))
+#define NORM(i1,j1,i2,j2) MAX1(ABS((i1)-(j1)),ABS((i2)-(j2)))
+	//IJ(i,j,l) returns the box number of i and j with respect to l
+	//if !j&l and !i$l -> 0 (box zero: lower left )
+	//if !j&l and  i$l -> 1 (box one:  lower right)
+	//if  j&l and !i$l -> 2 (box two:  upper left )
+	//if  j&l and  i$l -> 3 (box three:upper right)
+#define IJ(i,j,l)  ((j&l) ? ((i&l) ? 3:2 ) :((i&l) ? 1:0 ))
+	//I_IJ(k,l) returns l if first  bit of k is 1, else 0
+#define I_IJ(k,l)  ((k&1) ? l:0)
+	//J_IJ(k,l) returns l if second bit of k is 1, else 0
+#define J_IJ(k,l)  ((k&2) ? l:0)
+	/*}}}*/
+	/*DOCUMENTATION What is a QuadTree? {{{1
+	 * A Quadtree is a very simple way to group the vertices according
+	 * to their location. A square that holds all the points of the mesh
+	 * (or the geometry) is divided into 4 boxes. As soom as one box
+	 * hold more than 4 vertices, it is divided into 4 new boxes, etc...
+	 * There cannot be more than MAXDEEP (=30) subdivision.
+	 * This process is like a Dichotomy in dimension 2
+	 *
+	 *  + - -  -    - -    -    - - + -   - + - + - + - -     - - +
+	 *  |                           |       |   | X |             |
+	 *                                      + - + - +
+	 *  |                           |       |   |   |             |
+	 *                              + -   - + - + - +             +
+	 *  |                           |       |       |             |
+	 *                         
+	 *  |                           |       |       |             |
+	 *  + - -  -    - -    -    - - + -   - + -   - + - -     - - +
+	 *  |                           |               |             |
+	 *                         
+	 *  |                           |               |             |
+	 *                         
+	 *  |                           |               |             |
+	 *  |                           |               |             |
+	 *  + - -  -    - -    -    - - + -   -   -   - + - -     - - +
+	 *  |                           |                             |
+	 *                         
+	 *  |                           |                             |
+	 *                         
+	 *  |                           |                             |
+	 *                         
+	 *  |                           |                             |
+	 *  |                           |                             |
+	 *  |                           |                             |
+	 *  |                           |                             |
+	 *  |                           |                             |
+	 *  + - -  -    - -    -    - - + -   -   -   -   - -     - - +
+	 *
+	 * The coordinate system used in a quadtree are integers to avoid
+	 * round-off errors. The vertex in the lower left box has the coordinates
+	 * (0 0) 
+	 * The upper right vertex has the follwing coordinates:
+	 * 2^30 -1           2^30 -1        in decimal
+	 * 0 1 1 1 .... 1    0 1 1 1 .... 1 in binary
+	 *  \--   29  --/     \--   29  --/
+	 * Using the binaries is therefor very easy to locate a vertex in a box:
+	 * we just need to look at the bits from the left to the right (See ::Add)
+	 }}}1*/
+
+	/*Constructors/Destructors*/
+	/*FUNCTION QuadTree::QuadTree(Triangles * t,long nbv){{{1*/
+	QuadTree::QuadTree(Triangles * t,long nbv) : 
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.cpp/QuadTree)*/
+
+		lenStorageQuadTreeBox(t->nbvx/8+10),
+		th(t),
+		NbQuadTreeBox(0),
+		NbVertices(0),
+		NbQuadTreeBoxSearch(0),
+		NbVerticesSearch(0)
+	{ 
+	 if (nbv == -1) nbv = t->nbv;
+	 sb =new StorageQuadTreeBox(lenStorageQuadTreeBox);
+	 root=NewQuadTreeBox();
+	 if ( MaxISize <= MaxICoor){
+		 ISSMERROR("MaxISize <= MaxICoor");
+	 }
+	 for (int i=0;i<nbv;i++) 
+	  Add(t->vertices[i]);
+	}
+	/*}}}1*/
+	/*FUNCTION QuadTree::QuadTree(){{{1*/
+	QuadTree::QuadTree() : 
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.cpp/QuadTree)*/
+
+		lenStorageQuadTreeBox(100), // by default 100 vertices by box
+		th(0),                      // initial mesh = NULL
+		NbQuadTreeBox(0),           // initial number of quadtree boxes = 0
+		NbVertices(0),              // initial number of vertices = 0
+		NbQuadTreeBoxSearch(0),     // initial ?? = 0
+		NbVerticesSearch(0){        // initial ?? = 0
+			//create lenStorageQuadTreeBox (100) StorageQuadTreeBox elements
+			sb  =new StorageQuadTreeBox(lenStorageQuadTreeBox); 
+			//root=QuadTreeBox* pointer roward ??
+			root=NewQuadTreeBox();
+		}
+	/*}}}1*/
+	/*FUNCTION QuadTree::~QuadTree(){{{1*/
+	QuadTree::~QuadTree() {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.cpp/~QuadTree)*/
+
+		delete sb; 
+		root=0;
+	}
+	/*}}}1*/
+
+	/*Methods*/
+	/*FUNCTION QuadTree::Add{{{1*/
+	void  QuadTree::Add(MeshVertex &w){
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.cpp/Add)*/
+
+		QuadTreeBox** pb;
+		QuadTreeBox*  b;
+		register long i=w.i.x, j=w.i.y;
+		register long level=MaxISize;
+
+		//Get inital box (the largest)
+		pb = &root;
+
+		//Find the smallest box where w is located
+		while((b=*pb) && (b->n<0)){ 
+
+			//shift b->n by -1
+			b->n--;
+
+			//shifted righ by one bit: level=00000010 -> 00000001
+			level >>= 1;
+
+			//Get next subbox according to the bit value (level)
+			pb = &b->b[IJ(i,j,level)];
+		}
+
+		//OK, we have found b, a Subbox holding vertices (might be full)
+		//check that the vertex is not already in the box
+		if  (b) {      
+			if (b->n > 3 &&  b->v[3] == &w) return;
+			if (b->n > 2 &&  b->v[2] == &w) return;
+			if (b->n > 1 &&  b->v[1] == &w) return;
+			if (b->n > 0 &&  b->v[0] == &w) return;
+		}
+
+		//check that l is not 0 (this should not happen as MaxDeep = 30)
+		if (level==0){
+			ISSMERROR("level==0 cannot be true as it has been initialized as MaxISize = %i",MaxISize);
+		}
+
+		//Now, try to add the vertex, if the subbox is full (n=4), we have to divide it
+		//in 4 new subboxes
+		while ((b= *pb) && (b->n == 4)){ // the QuadTreeBox is full
+
+			//Copy the 4 vertices in the current QuadTreebox
+			MeshVertex* v4[4];
+			v4[0]= b->v[0];
+			v4[1]= b->v[1];
+			v4[2]= b->v[2];
+			v4[3]= b->v[3];
+
+			//set n as negative (box full -> holds 4 pointers toward subboxes and not 4 vertices)
+			b->n = -b->n;
+
+			//Initialize the 4 pointers toward the 4 subboxes
+			b->b[0]=b->b[1]=b->b[2]=b->b[3]=NULL;
+
+			// div the size by 2
+			level >>= 1;
+
+			//Put the four vertices in the new boxes
+			for (register int k=0;k<4;k++){
+				register int ij;
+				register QuadTreeBox* bb =  b->b[ij=IJ(v4[k]->i.x,v4[k]->i.y,level)];
+
+				// alloc the QuadTreeBox 
+				if (!bb) bb=b->b[ij]=NewQuadTreeBox(); 
+
+				//Copy the 4 vertices
+				bb->v[bb->n++] = v4[k];
+			}
+
+			//Get the subbox where w (i,j) is located
+			pb = &b->b[IJ(i,j,level)];
+		}
+
+		//  alloc the QuadTreeBox 
+		if (!(b = *pb)) b=*pb= NewQuadTreeBox();
+
+		//Add w
+		b->v[b->n++]=&w;
+
+		//Increase NbVertices by one (we have one new vertex)
+		NbVertices++;    
+	}
+	/*}}}1*/
+	/*FUNCTION QuadTree::NearestVertex{{{1*/
+	MeshVertex*  QuadTree::NearestVertex(Icoor1 i,Icoor1 j) {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.cpp/NearestVertex)*/
+
+		/*Build QuadTree*/
+		QuadTreeBox* pb[MaxDeep];
+		int      pi[MaxDeep];
+		Icoor1   ii[MaxDeep];
+		Icoor1   jj[MaxDeep];
+		register int level=0; // levelevelevel
+		register long n0;
+		register QuadTreeBox* b;
+		long     h=MaxISize,h0;
+		long     hb=MaxISize;
+		Icoor1   i0=0,j0=0;
+		//iplus= i projected in [0,MaxISize-1] (example: if i<0, i=0)
+		Icoor1   iplus( i<MaxISize?(i<0?0:i):MaxISize-1);
+		//jplus= j projected in [0,MaxISize-1] (example: if j>=MaxISize, j=MaxISize-1)
+		Icoor1   jplus( j<MaxISize?(j<0?0:j):MaxISize-1);
+		//initial nearest vertex pointer
+		MeshVertex*  vn=NULL;
+
+		//Get initial Quadtree box (largest)
+		b = root;
+
+		//if the tree is empty, return NULL pointer
+		if (!root->n) return vn; 
+
+		//else, find the non empty QuadTreeBox containing  the point (i,j)
+		while((n0=b->n)<0){
+
+			//shifted righ by one bit: hb2=01000000 -> 00100000
+			register Icoor1 hb2 = hb >> 1;
+			//Get QuadTreeBox number of size hb2 containing i;j (Macro)
+			register int      k = IJ(iplus,jplus,hb2);
+			//Get the corresponding box b0
+			register QuadTreeBox* b0=b->b[k];
+
+			// break if NULL box or empty
+			if (( b0 == NULL) || (b0->n == 0)) break;
+
+			//Get next Qudtree box
+			NbQuadTreeBoxSearch++;
+			b=b0;	
+			i0 += I_IJ(k,hb2); // i orign of QuadTreeBox (macro)
+			j0 += J_IJ(k,hb2); // j orign of QuadTreeBox 
+			hb = hb2; 
+		}
+
+		// if the current subbox is holding vertices, we are almost done
+		if ( n0>0 ){  
+			//loop over the vertices of the box and find the closest vertex
+			for(register int k=0;k<n0;k++){
+				I2 i2=b->v[k]->i;
+				h0=NORM(iplus,i2.x,jplus,i2.y);
+				if (h0<h){
+					h = h0;
+					vn = b->v[k];
+				}
+				NbVerticesSearch++;
+			}
+			return vn;
+		}
+
+		/* general case: the current box is empty, we have to get backwards
+			and find the closest not-empty box and find the closest vertex*/
+
+		//initialize pb pi ii and jj
+		pb[0]=b;                  //pointer toward the box b
+		pi[0]=b->n>0? (int)b->n:4;//number of vertices in the box
+		ii[0]=i0;                 // i coordinate of the box
+		jj[0]=j0;                 // j coordinate of the box
+
+		//initialize h as hb
+		h=hb;
+
+		//loop, until level=0
+		do {
+			//get current box
+			b= pb[level];
+
+			//Loop over the vertices in current box (if not empty!)
+			while (pi[level]--){
+
+				//k = number of vertices in the box if there are vertices
+				//k = 4 if the current box is pointing toward 4 other boxes
+				register int k=pi[level];
+
+				//if the current subbox is holding vertices,
+				if (b->n>0){ // MeshVertex QuadTreeBox not empty
+					NbVerticesSearch++;
+					I2 i2 =  b->v[k]->i;
+					h0 = NORM(iplus,i2.x,jplus,i2.y);
+					if (h0 <h){
+						h = h0;
+						vn = b->v[k];
+					}
+				}
+
+				else{
+					register QuadTreeBox* b0=b;
+					NbQuadTreeBoxSearch++;
+
+					//if the next box exists:
+					if ((b=b->b[k])){
+						//shifted righ by one bit: hb2=01000000 -> 00100000
+						hb>>=1;
+						register Icoor1 iii = ii[level]+I_IJ(k,hb);
+						register Icoor1 jjj = jj[level]+J_IJ(k,hb);
+
+						//if the current point is in b,go to next box
+						if (INTER_SEG(iii,iii+hb,iplus-h,iplus+h) && INTER_SEG(jjj,jjj+hb,jplus-h,jplus+h)){
+							pb[++level]=  b;
+							pi[level]= b->n>0 ?(int)  b->n : 4  ;
+							ii[level]= iii;
+							jj[level]= jjj;
+						}
+
+						//else go backwards
+						else{
+							//shifted righ by one bit: hb=001000000 -> 01000000
+							b=b0;
+							hb<<=1;
+						}
+					}
+					//Go backwards
+					else b=b0;
+				}
+			}
+
+			//else go backwards
+			//shifted righ by one bit: hb=001000000 -> 01000000
+			hb <<= 1;
+		} while (level--);
+
+		//return vn, nearest vertex
+		return vn;
+	}
+	/*}}}1*/
+	/*FUNCTION QuadTree::NearestVertexWithNormal{{{1*/
+	MeshVertex*  QuadTree::NearestVertexWithNormal(Icoor1 i,Icoor1 j) {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.cpp/NearestVertexWithNormal)*/
+
+		QuadTreeBox * pb[ MaxDeep ];
+		int  pi[ MaxDeep  ];
+		Icoor1 ii[  MaxDeep ], jj [ MaxDeep];
+		int l; // level
+		QuadTreeBox * b;
+		long     h =MaxISize,h0;
+		long     hb=MaxISize;
+		Icoor1  i0=0,j0=0;
+		Icoor1  iplus( i<MaxISize?(i<0?0:i):MaxISize-1);
+		Icoor1  jplus( j<MaxISize?(j<0?0:j):MaxISize-1);
+
+		MeshVertex *vn=0;
+
+		// init for optimisation ---
+		b = root;
+		register long  n0;
+		if (!root->n)
+		 return vn; // empty tree 
+
+		while( (n0 = b->n) < 0) 
+		  {
+			// search the non empty 
+			// QuadTreeBox containing  the point (i,j)
+			register Icoor1 hb2 = hb >> 1 ;
+			register  int k = IJ(iplus,jplus,hb2);// QuadTreeBox number of size hb2 contening i;j
+			register QuadTreeBox * b0= b->b[k];
+			if ( ( b0 == 0) || (b0->n == 0) ) 
+			 break; // null box or empty   => break 	    
+			NbQuadTreeBoxSearch++;
+			b=b0;	
+			i0 += I_IJ(k,hb2); // i orign of QuadTreeBox
+			j0 += J_IJ(k,hb2); // j orign of QuadTreeBox 
+			hb = hb2; 
+		  }
+
+
+		if ( n0 > 0) 
+		  {  
+			for(register int k=0;k<n0;k++)
+			  {
+				I2 i2 =  b->v[k]->i;
+				//   try if is in the right sens -- 
+				h0 = NORM(iplus,i2.x,jplus,i2.y);
+				if (h0 <h) {
+					h = h0;
+					vn = b->v[k];}
+					NbVerticesSearch++;
+			  }
+			if (vn) return vn; 
+		  }
+		// general case -----
+		// INITIALISATION OF THE HEAP 
+		l =0; // level 
+		pb[0]= b;
+		pi[0]=b->n>0 ?(int)  b->n : 4  ;
+		ii[0]=i0;
+		jj[0]=j0;
+		h=hb;
+		do {   // walk on the tree  
+			b= pb[l];
+			while (pi[l]--) // loop on 4 element of the box
+			  { 	      
+				int k = pi[l];
+
+				if (b->n>0) // MeshVertex QuadTreeBox none empty
+				  { 
+					NbVerticesSearch++;
+					I2 i2 =  b->v[k]->i;
+					// if good sens when try -- 
+
+					h0 = NORM(iplus,i2.x,jplus,i2.y);
+					if (h0 <h) 
+					  {
+						h = h0;
+						vn = b->v[k];
+					  }
+				  }
+				else // Pointer QuadTreeBox 
+				  { 
+					register QuadTreeBox *b0=b;
+					NbQuadTreeBoxSearch++;
+					if ((b=b->b[k])) 
+					  {
+						hb >>=1 ; // div by 2
+						register Icoor1 iii = ii[l]+I_IJ(k,hb);
+						register Icoor1 jjj = jj[l]+J_IJ(k,hb);
+
+						if  (INTER_SEG(iii,iii+hb,iplus-h,iplus+h) && INTER_SEG(jjj,jjj+hb,jplus-h,jplus+h)) 
+						  {
+							pb[++l]=  b;
+							pi[l]= b->n>0 ?(int)  b->n : 4  ;
+							ii[l]= iii;
+							jj[l]= jjj;
+
+						  }
+						else
+						 b=b0, hb <<=1 ;
+					  }
+					else
+					 b=b0;
+				  }
+			  }
+			hb <<= 1; // mul by 2 
+		} while (l--);
+
+		return vn;
+	}
+	/*}}}1*/
+	/*FUNCTION QuadTree::StorageQuadTreeBox::StorageQuadTreeBox{{{1*/
+	QuadTree::StorageQuadTreeBox::StorageQuadTreeBox(long ll,StorageQuadTreeBox *nn) {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.cpp/StorageQuadTreeBox)*/
+
+		len = ll;
+		n = nn;
+		b = new QuadTreeBox[ll];
+		for (int i = 0; i <ll;i++)
+		 b[i].n =0,b[i].b[0]=b[i].b[1]=b[i].b[2]=b[i].b[3]=0;
+		bc =b;
+		be = b +ll;
+		if (!b){
+			ISSMERROR("!b");
+		}
+	}
+	/*}}}1*/
+	/*FUNCTION QuadTree::ToClose {{{1*/
+	MeshVertex *   QuadTree::ToClose(MeshVertex & v,double seuil,Icoor1 hx,Icoor1 hy){
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.cpp/ToClose)*/
+
+		const Icoor1 i=v.i.x;
+		const Icoor1 j=v.i.y;
+		const R2 X(v.r);
+		const Metric  Mx(v.m);
+
+		QuadTreeBox * pb[ MaxDeep ];
+		int  pi[ MaxDeep  ];
+		Icoor1 ii[  MaxDeep ], jj [ MaxDeep];
+		register int l=0; // level
+		register QuadTreeBox * b;
+		Icoor1 h=MaxISize;
+		Icoor1 hb =  MaxISize;
+		Icoor1 i0=0,j0=0;
+
+		//  MeshVertex *vn=0;
+
+		if (!root->n)
+		 return 0; // empty tree 
+
+		// general case -----
+		pb[0]=root;
+		pi[0]=root->n>0 ?(int)  root->n : 4  ;
+		ii[0]=i0;
+		jj[0]=j0;
+		h=hb;
+		do {    
+			b= pb[l];
+			while (pi[l]--)
+			  { 	      
+				register int k = pi[l];
+
+				if (b->n>0) // MeshVertex QuadTreeBox none empty
+				  { 
+					NbVerticesSearch++;
+					I2 i2 =  b->v[k]->i;
+					if ( ABS(i-i2.x) <hx && ABS(j-i2.y) <hy )
+					  {
+						R2 XY(X,b->v[k]->r);
+						double dd;
+						if( (dd= LengthInterpole(Mx(XY), b->v[k]->m(XY)))  < seuil ){
+							return b->v[k]; 
+						  }
+					  }
+				  }
+				else // Pointer QuadTreeBox 
+				  { 
+					register QuadTreeBox *b0=b;
+					NbQuadTreeBoxSearch++;
+					if ((b=b->b[k]))
+					  {
+						hb >>=1 ; // div by 2
+						register long iii = ii[l]+I_IJ(k,hb);
+						register long jjj = jj[l]+J_IJ(k,hb);
+
+						if  (INTER_SEG(iii,iii+hb,i-hx,i+hx) && INTER_SEG(jjj,jjj+hb,j-hy,j+hy)) 
+						  {
+							pb[++l]=  b;
+							pi[l]= b->n>0 ?(int)  b->n : 4  ;
+							ii[l]= iii;
+							jj[l]= jjj;
+
+						  }
+						else
+						 b=b0, hb <<=1 ;
+					  }
+					else
+					 b=b0;
+				  }
+			  }
+			hb <<= 1; // mul by 2 
+		} while (l--);
+
+		return 0;
+	}
+	/*}}}1*/
+
+}
